## gatling 0.12

=== Makefile ===
prefix=/usr/local
BINDIR=${prefix}/bin
MANDIR=${prefix}/man
man1dir=$(MANDIR)/man1

TARGET=gatling httpbench dl bindbench mmapbench forkbench pthreadbench \
mktestdata manymapbench ioerr bench tlsgatling forksbench cgi getlinks \
acc hcat referrer hitprofile matchiprange

all: $(TARGET)

CC=gcc
CFLAGS=-pipe -Wall -O -I../libowfat/ -I/usr/local/include
LDFLAGS=-s -L../libowfat/ -lowfat

OBJS=mime.o ftp.o http.o smb.o common.o connstat.o
HTTPS_OBJS=mime.o ftp.o https.o smb.o common.o connstat.o

$(OBJS) https.o gatling.o: gatling.h version.h gatling_features.h

gatling: gatling.o $(OBJS) libsocket libiconv libcrypt md5lib
	$(CC) -o $@ gatling.o $(OBJS) $(LDFLAGS) `cat libsocket libiconv libcrypt md5lib`

httpbench: httpbench.o libsocket
	$(CC) -o $@ httpbench.o $(LDFLAGS) `cat libsocket`

dl: dl.o libsocket
	$(CC) -o $@ dl.o $(LDFLAGS) `cat libsocket`

bindbench: bindbench.o libsocket
	$(CC) -o $@ bindbench.o $(LDFLAGS) `cat libsocket`

mmapbench: mmapbench.o
	$(CC) -o $@ mmapbench.o $(LDFLAGS)

forkbench: forkbench.o
	$(CC) -o $@ forkbench.o $(LDFLAGS)

forksbench: forkbench.o
	$(CC) -static -o $@ forkbench.o $(LDFLAGS)

pthreadbench: pthreadbench.o
	$(CC) -o $@ pthreadbench.o $(LDFLAGS) -lpthread

mktestdata: mktestdata.o
	$(CC) -o $@ mktestdata.o $(LDFLAGS)

manymapbench: manymapbench.o
	$(CC) -o $@ manymapbench.o $(LDFLAGS)

bench: bench.o
	$(CC) -o $@ bench.o $(LDFLAGS)

ioerr: ioerr.o libsocket
	$(CC) -o $@ ioerr.o $(LDFLAGS) `cat libsocket`

acc: acc.o
	$(CC) -o $@ acc.o $(LDFLAGS)

cgi: cgi.o
	$(CC) -o $@ cgi.o $(LDFLAGS)

getlinks: getlinks.o
	$(CC) -o $@ getlinks.o $(LDFLAGS)

matchiprange: matchiprange.o
	$(CC) -o $@ matchiprange.o $(LDFLAGS)

gatling.o: version.h gatling.h havesetresuid.h

version.h: CHANGES
	(head -n 1 CHANGES | sed 's/\([^:]*\):/#define VERSION "\1"/') > version.h

%.o: %.c
	$(CC) -c $< -I. $(CFLAGS)

https.o: http.c
	$(CC) -c http.c -o $@ -I. $(CFLAGS) -DSUPPORT_HTTPS

hitprofile.o: referrer.c
	$(CC) -c referrer.c -o $@ -I. $(CFLAGS) -DALL

hitprofile: hitprofile.o

tlsgatling: gatling.c ssl.o version.h gatling.h libsocket libiconv libcrypt $(HTTPS_OBJS)
	-$(CC) -o $@ $(CFLAGS) gatling.c ssl.o $(HTTPS_OBJS) -DSUPPORT_HTTPS $(LDFLAGS) -lssl -lcrypto $(LDLIBS) `cat libsocket libiconv libcrypt`

libsocket: trysocket.c
	if $(CC) $(CFLAGS) -o trysocket trysocket.c >/dev/null 2>&1; then echo ""; else \
	if $(CC) $(CFLAGS) -o trysocket trysocket.c -lsocket >/dev/null 2>&1; then echo "-lsocket"; else \
	if $(CC) $(CFLAGS) -o trysocket trysocket.c -lsocket -lnsl >/dev/null 2>&1; then echo "-lsocket -lnsl"; \
	fi; fi; fi > libsocket
	rm -f trysocket

libiconv: tryiconv.c
	if $(CC) $(CFLAGS) -o tryiconv tryiconv.c >/dev/null 2>&1; then echo ""; else \
	if $(CC) $(CFLAGS) -o tryiconv tryiconv.c -liconv >/dev/null 2>&1; then echo "-liconv"; else \
	if $(CC) $(CFLAGS) -o tryiconv -I/usr/local/include tryiconv.c -L/usr/local/lib -liconv >/dev/null 2>&1; then \
	  echo "-L/usr/local/lib -liconv"; \
	fi; fi; fi > libiconv
	rm -f tryiconv

libcrypt: trycrypt.c
	if $(CC) $(CFLAGS) -o trycrypt trycrypt.c >/dev/null 2>&1; then echo ""; else \
	if $(CC) $(CFLAGS) -o trycrypt trycrypt.c -lcrypt >/dev/null 2>&1; then echo "-lcrypt"; \
	fi; fi > libcrypt
	rm -f trycrypt

md5lib: trymd5.c
	if $(CC) $(CFLAGS) -o trymd5 trymd5.c >/dev/null 2>&1; then echo ""; else \
	if $(CC) $(CFLAGS) -o trymd5 trymd5.c -lmd >/dev/null 2>&1; then echo "-lmd"; else \
	if $(CC) $(CFLAGS) -o trymd5 trymd5.c -lcrypto >/dev/null 2>&1; then echo "-lcrypto"; \
	fi; fi; fi > md5lib
	rm -f trymd5

havesetresuid.h: trysetresuid.c
	-rm -f $@
	if $(CC) $(CFLAGS) -o tryresuid $^ >/dev/null 2>&1; then echo "#define LIBC_HAS_SETRESUID"; fi > $@
	-rm -f tryresuid

install: gatling dl getlinks
	install -d $(BINDIR) $(man1dir)
	install $^ $(BINDIR)
	test -f tlsgatling && install tlsgatling $(BINDIR)
	install -m 644 gatling.1 bench.1 $(man1dir)

uninstall:
	rm -f $(BINDIR)/gatling $(BINDIR)/tlsgatling $(man1dir)/gatling.1 $(man1dir)/bench.1

clean:
	rm -f $(TARGET) *.o version.h core *.core libsocket libsocketkludge.a dummy.c libiconv libcrypt havesetresuid.h md5lib

cert: server.pem

rand.dat:
	-dd if=/dev/random of=rand.dat bs=1024 count=1

cakey.key: rand.dat
	openssl genrsa -out cakey.key -rand rand.dat 2048

cakey.csr: cakey.key
	openssl req -new -key cakey.key -out cakey.csr

cakey.pem: cakey.key cakey.csr
	openssl x509 -req -days 1780 -set_serial 1 -in cakey.csr \
	  -signkey cakey.key -out $@

server.pem: cakey.key cakey.pem
	cat cakey.key cakey.pem > server.pem

havealloca.h: tryalloca.c
	-rm -f $@
	echo "#include <stdlib.h>" > $@
	if $(DIET) $(CC) $(CFLAGS) -c tryalloca.c -DA >/dev/null 2>&1; then echo "#include <alloca.h>"; fi >> $@
	if $(DIET) $(CC) $(CFLAGS) -c tryalloca.c -DB >/dev/null 2>&1; then echo "#include <malloc.h>"; fi >> $@
	-rm -f tryalloca.o

bench.o bindbench.o common.o dl.o ftp.o gatling.o getlinks.o http.o \
httpbench.o ioerr.o rellink.o smb.o torrent.o: havealloca.h

=== debian/changelog ===
gatling (0.12-2) unstable; urgency=low

  * Plain and TLS version linked dynamically
  * Use debhelper instead of cdbs

 -- Roland Stigge <stigge@antcom.de>  Wed, 15 Dec 2010 18:09:54 +0100

gatling (0.12-1) unstable; urgency=low

  * New upstream release (Closes: #568039)

 -- Vedran Furač <vedran.furac@gmail.com>  Sat, 14 Aug 2010 15:05:14 +0200

gatling (0.11-1) unstable; urgency=low

  * Initial release (Closes: #568039)

 -- Vedran Furač <vedran.furac@gmail.com>  Sun, 07 Feb 2010 20:20:35 +0100

=== debian/control ===
Source: gatling
Section: net
Priority: optional
Maintainer: Vedran Furač <vedran.furac@gmail.com>
Uploaders: Roland Stigge <stigge@antcom.de>
Build-Depends: debhelper (>= 7.0.50), libowfat-dev, procps, zlib1g-dev, libssl-dev
Standards-Version: 3.9.1
Homepage: http://www.fefe.de/gatling/

Package: gatling
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: a high performance web server
 Features:
    * Small! (125k static Linux-x86 binary with HTTP, FTP and SMB support)
    * Fast! (measure for yourself, please)
    * Scalable!
    * Uses platform-specific performance and scalability APIs
    * connection keep-alive
    * IPv6 support
    * transparent content negotiation
    * With optional directory index generation
    * Will only serve world readable files
    * Supports FTP and FTP upload as well
    * CGI support for HTTP, also SCGI and FastCGI (over IP sockets)
    * .htaccess support
    * Can detect some common mime types itself, like file(1)
    * Read-only SMB support

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_build:
	make DIET= gatling bench tlsgatling

override_dh_auto_install:
	cp -a bench gatlingbench
	cp -a bench.1 gatlingbench.1
	cp -a gatling.1 tlsgatling.1

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

# Uncomment to examine a Webpage
# <Webpage URL> <string match>
http://www.fefe.de/gatling/ gatling-(.*)\.tar\.bz2

# Uncomment to examine a Webserver directory
#http://www.example.com/pub/gatling-(.*)\.tar\.gz

# Uncommment to examine a FTP server
#ftp://ftp.example.com/pub/gatling-(.*)\.tar\.gz debian uupdate

# Uncomment to find new files on sourceforge, for devscripts >= 2.9
# http://sf.net/gatling/gatling-(.*)\.tar\.gz

# Uncomment to find new files on GooglePages
# http://example.googlepages.com/foo.html gatling-(.*)\.tar\.gz

## gatling 0.12cvs20111112

=== debian/changelog ===
gatling (0.12cvs20111112-3) unstable; urgency=low

  * Fixed patch header of 05-manpage-dotfiles.patch

 -- Roland Stigge <stigge@antcom.de>  Sun, 27 Nov 2011 22:44:48 +0100

gatling (0.12cvs20111112-2) unstable; urgency=low

  * Included dotfile handling documentation into manpage, thanks to
    Benjamin Valentin (Closes: #649636)

 -- Roland Stigge <stigge@antcom.de>  Sun, 27 Nov 2011 22:12:24 +0100

gatling (0.12cvs20111112-1) unstable; urgency=low

  * New upstream CVS snapshot, including many bugfixes
  * Removed patches that are already present in upstream
  * Added ptlsgatling (PolarSSL version) in addition to tlsgatling
    (OpenSSL version), adding necessary build-dependencies

 -- Roland Stigge <stigge@antcom.de>  Sat, 12 Nov 2011 19:44:26 +0100

gatling (0.12-9) unstable; urgency=low

  * /etc/logrotate.d/gatling: Ignore errors on non-running daemon

 -- Roland Stigge <stigge@antcom.de>  Sun, 28 Aug 2011 20:11:22 +0200

gatling (0.12-8) unstable; urgency=low

  * Fixed /etc/logrotate.d/gatling: Group nobody -> adm

 -- Roland Stigge <stigge@antcom.de>  Mon, 15 Aug 2011 13:41:52 +0200

gatling (0.12-7) unstable; urgency=low

  * Added patch to fix setrlimit() bug (0 file descriptors available on
    VServers where EUID == 0, but no arbitrary setrlimit() allowed
  * Fixed init.d script output (missing newline)
  * debian/rules: Set -DSUPPORT_HTTPS for all objects in tlsgatling and
    separate out tlsgatling to separate "make" call (Closes: #634096)
  * Added writelog.c to provide a logrotatable alternative to former
    logsave from e2fsprogs
  * Added /etc/logrotate.d/gatling
  * Added CHANGES
  * Added patch from upstream CVS:
    - 08-fix-double-close-fd.patch from http.c rev 1.32

 -- Roland Stigge <stigge@antcom.de>  Sat, 13 Aug 2011 20:44:08 +0200

gatling (0.12-6) unstable; urgency=low

  * Integrated ranges and FastCGI bugfixes from upstream (Closes: #636361)

 -- Roland Stigge <stigge@antcom.de>  Wed, 03 Aug 2011 21:56:23 +0200

gatling (0.12-5) unstable; urgency=low

  * Fixed debian/watch
  * Added /etc/init.d/gatling and /etc/default/gatling
  * Added default index.html, adapted from apache 2 package
  * Added postinst and postrm to add/remove default index.html
  * Added download tool "dl" as /usr/bin/gatling-dl

 -- Roland Stigge <stigge@antcom.de>  Sat, 16 Jul 2011 13:43:39 +0200

gatling (0.12-4) unstable; urgency=low

  * Removed temporary fix for tlsgatling since libowfat is a shared lib now

 -- Roland Stigge <stigge@antcom.de>  Sat, 09 Jul 2011 22:02:18 +0200

gatling (0.12-3) unstable; urgency=low

  * Added README.php from upstream to binary package
  * debian/control: Standards-Version: 3.9.2

 -- Roland Stigge <stigge@antcom.de>  Sun, 03 Jul 2011 15:41:11 +0200

## gatling 0.12cvs20120114

=== debian/changelog ===
gatling (0.12cvs20120114-4) stable; urgency=medium

  *  PolarSSL was updated to 1.2.9 in DSA 2782 (due to security fixes which
     were not backportable to the older releases). Version 1.2.0 introduces
     several non-backwards-compatible API changes (fully mentioned here:
     https://polarssl.org/tech-updates/releases/polarssl-1.2.0-released
     - Rename cipher suites names
     - Remove call to removed ssl_set_scb() function, TLS session cache is
       handled internally. Also remove the functions my_get_session() and
       my_set_session() used for that and adapt the ssl_set_session() call.
     Thanks to Moritz Mühlenhoff for the patch (Closes: #736318)

 -- Roland Stigge <stigge@antcom.de>  Tue, 28 Jan 2014 21:18:43 +0100

gatling (0.12cvs20120114-3) unstable; urgency=low

  * Adding two patches for path traversal vulnerabilities (FTP, HTTP).
    Backport fixes from upstream 0.13. Thanks to Jann Horn! (Closes: #693076)

 -- Roland Stigge <stigge@antcom.de>  Mon, 12 Nov 2012 22:11:35 +0100

gatling (0.12cvs20120114-2) unstable; urgency=low

  * Adding two patches to fix CGI POST uploads

 -- Roland Stigge <stigge@antcom.de>  Sun, 22 Jan 2012 17:51:40 +0100

gatling (0.12cvs20120114-1) unstable; urgency=low

  * New upstream CVS snapshot
    - Fixes PolarSSL usage (Closes: #655777)
  * Adding patch to fix bad polarssl usage (wrong argument order of
    md5_finish)

 -- Roland Stigge <stigge@antcom.de>  Sat, 14 Jan 2012 14:25:43 +0100

=== debian/control ===
--- 
+++ 
@@ -3,18 +3,18 @@
 Priority: optional
 Maintainer: Vedran Furač <vedran.furac@gmail.com>
 Uploaders: Roland Stigge <stigge@antcom.de>
-Build-Depends: debhelper (>= 7.0.50), libowfat-dev, procps, zlib1g-dev, libssl-dev
-Standards-Version: 3.9.1
+Build-Depends: debhelper (>= 7.0.50), libowfat-dev, procps, zlib1g-dev, libssl-dev, libpolarssl-dev (>= 1.0.0-2)
+Standards-Version: 3.9.2
 Homepage: http://www.fefe.de/gatling/
 
 Package: gatling
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Description: a high performance web server
+Description: high performance web server and file server
  Features:
-    * Small! (125k static Linux-x86 binary with HTTP, FTP and SMB support)
-    * Fast! (measure for yourself, please)
-    * Scalable!
+    * Small (125k Linux-x86 binary with HTTP, FTP and SMB support)
+    * Fast (measure for yourself, please)
+    * Scalable
     * Uses platform-specific performance and scalability APIs
     * connection keep-alive
     * IPv6 support

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

writelog: writelog.c
	$(CC) $(CFLAGS) -Wall -o $@ $<

override_dh_auto_build: writelog
	make DIET= ptlsgatling
	mv ptlsgatling ptlsgatling.BACKUP
	make clean
	make DIET= tlsgatling
	mv tlsgatling tlsgatling.BACKUP
	make clean
	make DIET= gatling bench dl
	mv tlsgatling.BACKUP tlsgatling
	mv ptlsgatling.BACKUP ptlsgatling
	cp -a bench gatling-bench
	cp -a bench.1 gatling-bench.1
	cp -a dl gatling-dl
	cp -a dl.1 gatling-dl.1
	cp -a gatling.1 tlsgatling.1
	cp -a gatling.1 ptlsgatling.1

override_dh_installchangelogs:
	dh_installchangelogs CHANGES

# empty targets
override_dh_auto_install:

## gatling 0.13

=== Makefile ===
--- 
+++ 
@@ -14,7 +14,7 @@
 LDFLAGS=-s -L../libowfat/ -lowfat
 
 OBJS=mime.o ftp.o http.o smb.o common.o connstat.o
-HTTPS_OBJS=mime.o ftp.o https.o smb.o common.o connstat.o
+HTTPS_OBJS=mime.o ftp.c https.o smb.c common.c connstat.o
 
 $(OBJS) https.o gatling.o: gatling.h version.h gatling_features.h
 
@@ -67,6 +67,7 @@
 	$(CC) -o $@ matchiprange.o $(LDFLAGS)
 
 gatling.o: version.h gatling.h havesetresuid.h
+tlsgatling ptlsgatling: havesetresuid.h libsocket libiconv libcrypt
 
 version.h: CHANGES
 	(head -n 1 CHANGES | sed 's/\([^:]*\):/#define VERSION "\1"/') > version.h

=== debian/changelog ===
gatling (0.13-6) unstable; urgency=medium

  * Added 10-mbedtls.patch to switch from polarssl to mbedtls,
    thanks to James Cowgill (Closes: #808059)
  * debian/control: Standards-Version: 3.9.6

 -- Roland Stigge <stigge@antcom.de>  Sat, 16 Jan 2016 16:13:21 +0100

gatling (0.13-5) unstable; urgency=low

  * Fix FTBFS by adjusting to new polarssl API (Closes: #728625)

 -- Roland Stigge <stigge@antcom.de>  Mon, 04 Nov 2013 21:29:38 +0100

gatling (0.13-4) unstable; urgency=low

  * Integrate new upstream version 0.13 into unstable, fixes build issue
    (Closes: #707370)

 -- Roland Stigge <stigge@antcom.de>  Thu, 09 May 2013 15:51:14 +0200

gatling (0.13-3) experimental; urgency=low

  * Fix symbol lookup error via versioned dependency on libowfat
    (Closes: #704697)

 -- Roland Stigge <stigge@antcom.de>  Fri, 05 Apr 2013 11:26:50 +0200

gatling (0.13-2) experimental; urgency=low

  * debian/control: Build-Depends: libpolarssl-dev (>= 1.2.0-1)

 -- Roland Stigge <stigge@antcom.de>  Sun, 04 Nov 2012 14:45:22 +0100

gatling (0.13-1) experimental; urgency=low

  * New upstream release

 -- Roland Stigge <stigge@antcom.de>  Sat, 03 Nov 2012 15:47:03 +0100

gatling (0.12cvs20120601-1) unstable; urgency=low

  * New upstream release
    - Removed 04-fix-ptlsgatling-usage.patch, fixed upstream now

 -- Roland Stigge <stigge@antcom.de>  Sat, 02 Jun 2012 19:00:17 +0200

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,13 @@
 Priority: optional
 Maintainer: Vedran Furač <vedran.furac@gmail.com>
 Uploaders: Roland Stigge <stigge@antcom.de>
-Build-Depends: debhelper (>= 7.0.50), libowfat-dev, procps, zlib1g-dev, libssl-dev, libpolarssl-dev (>= 1.0.0-2)
-Standards-Version: 3.9.2
+Build-Depends: debhelper (>= 9), libowfat-dev (>= 0.29-2), procps, zlib1g-dev, libssl-dev, libmbedtls-dev
+Standards-Version: 3.9.6
 Homepage: http://www.fefe.de/gatling/
 
 Package: gatling
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, libowfat0 (>= 0.29-2)
 Description: high performance web server and file server
  Features:
     * Small (125k Linux-x86 binary with HTTP, FTP and SMB support)

=== debian/rules ===
--- 
+++ 
@@ -1,10 +1,15 @@
 #!/usr/bin/make -f
+
+CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
+CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
+CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
+LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
 
 %:
 	dh $@
 
 writelog: writelog.c
-	$(CC) $(CFLAGS) -Wall -o $@ $<
+	$(CC) $(CFLAGS) $(LDFLAGS) -Wall -o $@ $<
 
 override_dh_auto_build: writelog
 	make DIET= ptlsgatling

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

# <Webpage URL> <string match>
http://www.fefe.de/gatling/ http://dl.fefe.de/gatling-(.*)\.tar\.bz2
